%{
#include <stdio.h>  /* K.Nagami added */
#include <stdlib.h> /* K.Nagami added */
#include <string.h> /* K.Nagami added */

extern int lineno; /* K.Nagami added: instance is in `asm.y' */
%}
%%
[ \t]+ {}
(ADD|add)  { yylval = 0x08 /*00000*/ ; return OP_R;}
(SUB|sub)  { yylval = 0x0A /*00010*/ ; return OP_R;}
(AND|and)  { yylval = 0x0C /*00100*/ ; return OP_R;}
(OR|or)    { yylval = 0x0E /*00101*/ ; return OP_R;}
(XOR|xor)  { yylval = 0x10 /*00110*/ ; return OP_R;}
(SL|sl)    { yylval = 0x12 /*01000*/ ; return OP_R;}
(SLT|slt)  { yylval = 0x14 /*01001*/ ; return OP_R;}
(SGT|sgt)  { yylval = 0x16 /*01100*/ ; return OP_R;}

(ADDI|addi) { yylval = 0x09 /*00000*/ ; return OP_I5;}
(SUBI|subi) { yylval = 0x0B /*00010*/ ; return OP_I5;}
(ANDI|andi) { yylval = 0x0D /*00100*/ ; return OP_I5;}
(ORI|ori)   { yylval = 0x0F /*00101*/ ; return OP_I5;}
(XORI|xori) { yylval = 0x11 /*00110*/ ; return OP_I5;}
(SLI|sli)   { yylval = 0x13 /*01000*/ ; return OP_I5;}
(SLTI|slti) { yylval = 0x15 /*01001*/ ; return OP_I5;}
(SGTI|sgti) { yylval = 0x17 /*01100*/ ; return OP_I5;}

(LB|lb)    { yylval = 0x00 /*01000*/ ; return OP_I5_2;}
(LBU|lbu)  { yylval = 0x01 /*01001*/ ; return OP_I5_2;}
(LW|lw)    { yylval = 0x03 /*01100*/ ; return OP_I5_2;}

(SB|sb)    { yylval = 0x02 /*10000*/ ; return OP_I5_3;}
(SW|sw)    { yylval = 0x04 /*10010*/ ; return OP_I5_3;}

(LHI|lhi)  { yylval = 0x05 /*01010*/ ; return OP_I8;}
(LLI|lli)  { yylval = 0x06 /*01011*/ ; return OP_I8;}

(BEQZ|beqz) { yylval = 0x18 /*10100*/ ; return OP_BZ;}
(BNEZ|bnez) { yylval = 0x19 /*10101*/ ; return OP_BZ;}

(JR|jr)     { yylval = 0x1B /*11100*/ ; return OP_JR;}
(LINK|link) { yylval = 0x07 /*00111*/ ; return OP_LINK;}

(J|j)      { yylval = 0x1A /*00100*/ ; return OP_J;}

(RST|rst)   { yylval = 0x1C /*00111*/ ; return OP_J_2; }
(HALT|halt) { yylval = 0x1D /*00110*/ ; return OP_J_2; }
(NOP|nop)   { yylval = 0x1E /*00000*/ ; return OP_J_2; }

\.(ORG|org) { return OP_0; }
\.(DB|db)   { return DB; }
\.(DW|dw)   { return DW; }
\.(TESTER|tester) { return TESTER; }

[%|R|r][0-7] { yylval = (unsigned int)(yytext[1]-'0'); return REG;
             /* K.Nagami modified: `R[0-7] -> (R|r)[0-7]' */ }

(LOW|low)           { return(LOW);}
(HIGH|high)         { return(HIGH);}
\.(DUP|dup)           { return(DUP);}
[0-9]+                { sscanf(yytext ,"%d",&yylval);
                         return(NUMBER);}
-[0-9]+                { sscanf(yytext ,"%d",&yylval);
                         return(NUMBER);}
0[Xx][0-9a-fA-F]+     { sscanf(yytext+2 ,"%x",&yylval);
                        return(NUMBER);}
0[Oo][0-9]+           { sscanf(yytext+2 ,"%o",&yylval);
                        return(NUMBER);}
0[Bb][0-9]+           { int i=0;
                        yylval = 0;
                        while((yytext+2)[i] != '\0'){
			  if((yytext+2)[i]-'0') yylval++;
                          if((yytext+2)[++i] != '\0') yylval <<= 1;
			}
                        return(NUMBER);}
@[a-zA-Z0-9_]*        { strcpy(label,yytext); return(LABEL);
                         /* K.Nagami modified: `[a-zA-Z].*' -> `@.*' */ }
[;].*                 {}
"\n"                  { ++lineno; /* K.Nagami added */}
"'"."'"               { yylval = yytext[1]; return(CHAR);}
.                     { return(yytext[0]); }
