%{ 
#include <stdio.h>  /* K.Nagami added */
#include <stdlib.h> /* K.Nagami added */
#include <string.h> /* K.Nagami added */
void yyerror(char *___msg); /* K.Nagami added */

#define YYSTYPE unsigned int 
#define MAX 256
#include <stdio.h>
#include <math.h>
void out( int loc , unsigned int code);
void data_out( int loc , unsigned int code);
void label_address_table_output();
char label[21];
char label_table[MAX][21];
int loc_table[MAX];
int data_size[MAX];
int lbl_num,max_lbl;
extern int loc;
extern int pass2;

int lineno; /* K.Nagami added */
%}

%token LABEL
%token NUMBER
%token HIGH LOW
%token DW DB TESTER
%token DUP
%token CHAR
%token OP_R 
%token OP_I5 OP_I5_2 OP_I5_3
%token OP_I8 OP_BZ OP_LINK
%token OP_JR
%token OP_J OP_J_2
%token OP_0
%token REG
%start kasm /* K.Nagami added */
%%
kasm           : { lineno = 1; } source /* K.Nagami added */
               ;

source         :
               | line source
               ;
line           : LABEL{ if(!pass2){
                          strcpy(label_table[lbl_num],label);
                          loc_table[lbl_num]=loc;
			  data_size[lbl_num] = 0;
			}
                      } ':' statement{
			max_lbl = lbl_num++;}
               | statement
               ;
statement      : OP_0 NUMBER { 
                        loc = ($2 & 0xfffffffc);
			if(pass2) printf("### START ADDRESS : %04x ###\n",loc);
		      }
               | OP_R REG ',' REG ',' REG {
                   if(pass2) out( loc ,$1<<11 | $4<<8 | $6<<5 | $2<<2);
		   loc+=2;
		 }
               | OP_I5 REG ',' REG ',' immediate5 {
                   if(pass2) out(loc ,$1<<11 | $4<<8 | $2<<5 | $6);
		   loc+=2;
		 }
               | OP_I5_2 REG ',' immediate5 '(' REG ')' {
		   if((loc & 0x002)!=0) yyerror("Iregal Load inst place");
		   if(pass2) out(loc, $1<<11 | $6<<8 | $2<<5 | $4);
		   loc+=2;
		 }
               | OP_I5_3 immediate5 '(' REG ')' ',' REG {
		   if((loc & 0x002)!=0) yyerror("Iregal Store inst place");
                   if(pass2) out(loc ,$1<<11 | $4<<8 | $7<<5 | $2);
		   loc+=2;
		 }
               | OP_I8 REG ',' immediate8 {
                   if(pass2) out( loc ,$1<<11 | $2<<8 | $4);
		   loc+=2; 
		      }
               | OP_BZ REG ',' immediatel {
		   if((loc & 0x002)!=0) yyerror("Iregal Jump inst place");
                   if(pass2){
		     if( (abs($4 - loc) >= 0x3ff) || (($4 & 0x003) != 0))
		       yyerror("Jump address error");
		     else
		       out( loc ,$1<<11 | $2<<8 | (($4-loc)>>2 & 0xff) );
		   }
		   loc+=2; 
		 }
               | OP_LINK REG ',' immediatel {
                   if(pass2){
		     if( (abs($4 - loc) >= 0x3ff) || (($4 & 0x003) != 0))
		       yyerror("Link address error");
		     else
		       out( loc ,$1<<11 | $2<<8 | (($4-loc+2)>>2 & 0xff) );
		   }
		   loc+=2; 
		 }
               | OP_JR REG  {
		   if((loc & 0x002)!=0) yyerror("Iregal Jump inst place");
                   if(pass2) out( loc ,$1<<11 | $2<<8 | 0);
		   loc+=2; 
		      }
               | OP_J immediate11{
		    if((loc & 0x002)!=0) yyerror("Iregal Jump inst place");
                    if(pass2){
		      if( (abs(loc - $2) >= 0x1fff) || (($2 & 0x003) != 0))
			  yyerror("Jump address error");
		          /* K.Nagami modified: original calls `fprintf' */
		      else
			out( loc ,$1<<11 | ((($2-loc)>>2) & 0x7ff) );
		    }
		    loc+=2;
		  }
               | OP_J_2{
		        if(pass2) out( loc , $1<<11);
		        loc+=2;
		      }
               | DB NUMBER DUP '(' dup_byte ')' {
                           /* K.Nagami modified: word size = 2 */
                           int line;
		           line = (int)ceil( $2 / 2.0 );
			   if(pass2){
			     int i;
			     for(i=1;i<=line;i++){
			       /*  out(loc, $5 | ($5<<8));*/
			       data_out(loc, $5 | ($5<<8));
			     }
			   }
			   else data_size[lbl_num] = line * 2;
			   loc+=2;
			   }
               | DW NUMBER DUP '(' NUMBER ')' 
                        { 
                           if(pass2){
			     int i;
			     for(i=1;i<=$2;i++){
/*			     out(loc , $5 );*/
			       data_out(loc , $5 );
			     }
			   }
			   else data_size[lbl_num] = $2 * 2;
			   loc+=2;
			 }
               | TESTER NUMBER NUMBER
                    { 
		      if(pass2)
			printf("memset $TESTER_PATH\\/cell X%x X%x\n", $2, $3);
		    }
               ;
dup_byte       : CHAR   {$$ = $1 & 0xff; }
               | NUMBER {$$ = $1 & 0xff; }
               ;
immediate5     : LABEL { if(pass2) $$ = (ref_table(label) & 0x1f); }
               | NUMBER { if(pass2) $$ = ($1 & 0x1f); }
               ;
immediate8     : LABEL { if(pass2) $$ = (ref_table(label) & 0xff); }
               | LOW  LABEL { if(pass2) $$ = (ref_table(label) & 0xff); }
               | HIGH LABEL { if(pass2) $$ = (ref_table(label)>>8 & 0xff); }
               | NUMBER { if(pass2) $$ = ($1 & 0xff); }
               ;
immediatel     : LABEL { if(pass2) $$ = (ref_table(label)); }
               ;
immediate11    : LABEL { if(pass2) $$ = (ref_table(label)); }
               ;
%%
#include "asmlex.c"

void out( int loc , unsigned int code)
{
  int i,j;
  extern int output;
  extern char imemoryportname[];
  extern int parthenon;

  if(parthenon) printf("memset %s X%x  ",imemoryportname,loc/2);
  else printf("%4x  ",loc); /* K.Nagami modified: %8x -> %4x */
/* hex output */
  if(output == 0){
    if(parthenon) printf("X");
    printf("%04x ",code);/* K.Nagami modified: %08x -> %04x */
  }
/* binary output */
/* K.Nagami modified: 31 -> 15 */
  if(output == 1){
    if(parthenon) printf("B");
    for(i=0;i<5;i++) putchar(code&(1<<(15-i))?'1':'0');
    for(;i<5+3;i++) putchar(code&(1<<(15-i))?'1':'0');
    for(;i<5+3+8;i++) putchar(code&(1<<(15-i))?'1':'0');
  }
  printf("\n");
}


void data_out( int loc , unsigned int code)
{
  int i,j;
  extern int output;
  extern char dmemoryportname[];
  extern int parthenon;

  if(parthenon) printf("memset %s X%x  ",dmemoryportname,loc);
  else printf("%4x  ",loc); 
/* hex output */
  if(output == 0){
    if(parthenon) {printf("X");printf("%02x ",(code & 0xff) );}
    else printf("%04x ",code);
  }
/* binary output */
  if(output == 1){
    if(parthenon){
      printf("B");
      for(i=8;i<16;i++) putchar(code&(1<<(15-i))?'1':'0');
    }
    else for(i=0;i<16;i++) putchar(code&(1<<(15-i))?'1':'0');
  }
/* 2 kaime */
  if(parthenon){
    /* hex output */
    if(output == 0) printf("X%02x ",( (code>>8) & 0xff) );
    /* binary output */
    if(output == 1){
      printf(" B");
      for(i=0;i<8;i++) putchar(code&(1<<(15-i))?'1':'0');
    }
  }
  printf("\n");
}


int ref_table(char *label)
{
  int i=0;
  while(1){
    if(!strcmp(label,label_table[i])) return( loc_table[i]);
    if(++i>max_lbl) return(-1);
  }
}

void label_address_table_output()
{
  extern char dmemoryportname[];
  int i,j;
  for(i=0; i<=max_lbl; i++){
    if(data_size[i]){
      printf("rpt_add rep%d \"%s =", i, label_table[i]);
      for(j=0;j<data_size[i];j++) printf(" %%2x");
      printf("\\n\"");
      for(j=0;j<data_size[i];j++) printf(" %s@X%x", dmemoryportname, loc_table[i]+j);
      printf("\n");
    }
  }
}

/* K.Nagami added */
void yyerror(char *___msg)
{
    fprintf(stderr, "kasm error at line %d(token `%s'): %s\n",
	    lineno, yytext, ___msg);
    exit(-1);
}
